def calculate_placement(N, times):
    times.sort()
    domestic_team_time = times[2 * (N // 4)]
    return domestic_team_time

def main():
    N = int(input())
    times = list(map(int, input().split()))
    query = input().strip()

    if query == "max":
        result = calculate_placement(N, times)
    elif query == "min":
        times.reverse()
        result = calculate_placement(N, times)
    else:
        print("Invalid query!")
        return

    print(result)

if __name__ == "__main__":
    main()