#include <bits/stdc++.h>
using namespace std;
const int MAXN = 1000006;
const int inf = 2147483647;
const int mod = 1000000007;

int n, a[MAXN];

int add(int x, int y){return (x+y)%mod;}
int mul(int x, int y){return (1ll*x*y)%mod;}
int binpow(int x, int y){ // x na y
    int m = 1;
    while(y != 0){
        if(y&1) m = mul(m, x);
        x = mul(x, x);
        y >>= 1;
    }
    return m;
}
int dp[MAXN+50];

int s[3*MAXN], sn;
int t1, t2;
int Read(int x, int y, int k){
    if(x > t2 || y < t1) return 0;
    if(t1 <= x && y <= t2) return s[k];
    const int mid = (x+y)/2;
    return add(Read(x, mid, 2*k+1), Read(mid+1, y, 2*k+2));
}
int read(int x, int y){t1 = x; t2 = y; return Read(0, sn-1, 0);}

void Update(int x, int y, int k){
    if(x > t1 || y < t1) return;
    if(x == y){
        s[k] = t2;
        return;
    }
    const int mid = (x+y)/2;
    Update(x, mid, 2*k+1);
    Update(mid+1, y, 2*k+2);
    s[k] = add(s[2*k+1], s[2*k+2]);
}
void update(int i, int v){t1 = i; t2 = v; Update(0, sn-1, 0);}


signed main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cin >> n; for(int i = 0; i < n; ++i) cin >> a[i]; sn = n;
    /*dp[n-1] = 1;
    for(int i = n-2; i >= 0; --i){
        for(int j = i+1; j < min(n, i+a[i]+1); ++j){
            dp[i] = add(dp[i], dp[j]);
        }
    }
    cout << dp[0];*/
    update(n-1, 1);
    for(int i = n-2; i >= 0; --i){
        int t = read(i+1, min(n, i+a[i]+1)-1);
        update(i, t);
    }
    cout<< read(0, 0);
    //cout << "s:  ";for(int i = 0; i < 16; ++i) cout << s[i] << ' ';

    return 0;
}