#include <iostream>

using namespace std;

const int MOD = 1e9 + 7, mxN = 2e6+100;
int bit[mxN];
void f(int &u, int &v) {
    u += v;
    if (u >= MOD)   u-=MOD;
}
void add(int idx, int x) {
    while (idx < mxN) {
        f(bit[idx], x);
        idx |= (idx + 1);
    }
}
int fix(int x) {
    if (x < 0)  return x + MOD;
}
int sum(int idx){
    int s = 0;
    while (idx >= 0) {
        f(s, bit[idx]);
        idx &= (idx + 1);
        idx--;
    }
    return s;
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    int a[n+2];
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    add(a[1]+1, 1);
    for (int i = 2; i < n; ++i) {
        add(a[i]+i, fix(sum(mxN - 1) - sum(i-1)));
    }
    cout << fix(sum(mxN-1) - sum(n-1)) << '\n';
    return 0;
}