#include <bits/stdc++.h>
using namespace std;
const int maxn = 1e7 + 5;
typedef long long ll;
bool p[maxn];
void sieve(){
    for(int i = 1; i < maxn; ++i)
        p[i] = 1;
    for(int i = 4; i < maxn; i += 2)
        p[i] = 0;
    for(int i = 3; i * i < maxn; ++i){
        if(p[i]){
            for(int j = i * i; j < maxn; j += i)
                p[j] = 0;
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0);
    sieve();
    vector<ll> prost;
    for(int i = 2; i < maxn; ++i)
        if(p[i]) prost.push_back(i);
    int n = prost.size();
    vector<ll> pref(n + 1);
    pref[0] = prost[0];
    for(int i = 1; i < n; ++i)
        pref[i] = pref[i - 1] + prost[i];
    int q; cin >> q;
    while(q--){
        int a, b; cin >> a >> b; a--; b--;
        if(a == 0) cout << pref[b] << '\n';
        else cout << pref[b] - pref[a - 1] << '\n';
    }
    return 0;
}