#include <iostream>
#include <cmath>

using namespace std;

bool isprime(int x){
    if (x==1) return false;
    if (x%2==0) return false;
    if (x%3==0) return false;
    int l=int(sqrt(x)+1);
    for (int i=1;i<l;i=6*i){
        if (x%(6*i-1)==0 && 6*i-1<x){
            return false;
        }
        if (x%(6*i+1)==0 && 6*i+1<x){
            return false;
        }
    }
    return true;
}

int sumofprimes(int a, int b){
    if (a==b) return a;
    int v=a+b;
    if (a==2) v+=3;
    int s;
    if ((a-1)%6==0){
        s=a+5;
    }
    else if (a!=3){
        s=a+7;
        if (isprime(a+2)) v+=a+2;
    }
    if (a==3) s=6;
    if (isprime(b-2)) v+=b-2;
    for (int i=s;i<b-1;i+=6){
        if (i>b-2) break;
        if (isprime(i-1)){
            v+=i-1;
        }
        if (isprime(i+1)){
            v+=i+1;
        }
    }
    return v;
}

int getnthprime(int n){
    if (n==1) return 2;
    if (n==2) return 3;
    int ct=2;
    for (int i=1;true;i++){
        if (isprime(6*i-1)) ct++;
        if (ct==n) return 6*i-1;
        if (isprime(6*i+1)) ct++;
        if (ct==n) return 6*i+1;
    }
}

int main(){
    int input1,input2;
    int n;
    cin >> n;
    int bounds[2*n];
    for (int i=0;i<n;i++){
        cin >> input1 >> input2;
        bounds[2*i]=input1;
        bounds[2*i+1]=input2;
    }
    for (int i=0;i<n;i++){
        int p1=getnthprime(bounds[2*i]);
        int p2=getnthprime(bounds[2*i+1]);
        if (bounds[2*i+1]-bounds[2*i]==1){
                cout << p1+p2 << endl;
        }
        else cout << sumofprimes(p1,p2) << endl;
    }
}