#include <bits/stdc++.h>
using namespace std;

void printbool(vector<bool> niz){
    for(int i = 0; i < niz.size(); i++){
        cout << i << " " << niz[i] << endl;
    }
    cout << endl;
}

long long int zbir(int a, int b, vector<bool> niz){
    long long int rez = 0;
    int rbrojprostih = 0;
    int n = niz.size();
    for(int i = 0; i < n; i++){
        if(niz[i] == 1){
            rbrojprostih++;
            if(rbrojprostih > b){
                break;
            }
            bool vrednost1 = (rbrojprostih >= a);
            bool vrednost2 = (rbrojprostih <= b);
            if(vrednost1 && vrednost2){
                rez += i;
            }
        }
    }
    return rez;
}


vector<bool> eratosten(vector<bool> niz){
    int k = 1;
    int prost = 2;
    int n = niz.size();
    while((prost * prost) < n){
        for(int i = 1; i < (n / prost); i++){
            if(i != 1){
                niz[i * prost] = false;
            }
        }
        if(prost == 2){
            prost = 3;
        }
        else if(prost == 3){
            prost = 5;
        }
        else if((prost % 6) == 5){
            prost += 2;
        }
        else{
            prost = 6 * k + 1;
            k++;
        }
    }
    return niz;
}

int main(){
    ios_base::sync_with_stdio(false);
    int Q;
    cin >> Q;
    vector<bool> niz(100000, 1);
    niz[0] = 0;
    niz[1] = 0;
    niz = eratosten(niz);
    int a, b;
    for(int i = 0; i < Q; i++){
        cin >> a >> b;
        cout << zbir(a, b, niz) << endl;
    }
    return 0;
}