#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

struct patika {
    string ime;
    int vrednost;
};

int main() {

    int n; cin >> n;
    vector<patika> patike(n);
    for (int i = 0; i < n; i++) {
        cin >> patike[i].ime >> patike[i].vrednost;
    }

    sort(patike.begin(),patike.end(),[](patika a, patika b) {
         if (a.vrednost == b.vrednost) {return a.ime < b.ime;}
         return a.vrednost > b.vrednost;
         });

    int k; cin >> k;
    for (int i = 0; i < k; i++) {
        int budget; cin >> budget;
        int najskuplje = -1;
        if (budget < patike[patike.size()-1].vrednost) {
            cout << "nema\n";
        }
        else {
            for (int j = 0; j < n; j++) {
                if (patike[j].vrednost <= budget && najskuplje == patike[j].vrednost) {
                    cout << patike[j].ime << " " << patike[j].vrednost << "\n";
                }
                else if (najskuplje == -1 && patike[j].vrednost <= budget) {
                    najskuplje = patike[j].vrednost;
                    cout << patike[j].ime << " " << patike[j].vrednost << "\n";
                }
                else if (najskuplje > patike[j].vrednost) {
                    break;
                }
            }
        }


    }

    return 0;
}